# coding: utf-8

"""
    Maestro API

    Maestro authors and executes experiences that allow non-coders the ability to define Simple Business Process without having to write code and to deploy them seamlessly without having to have development expertise  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: devcenter@docusign.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from docusign_maestro.client.configuration import Configuration


class DSLoopStep(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'expression': 'DSWorkflowComparisonExpression',
        'id': 'str',
        'loop_steps': 'list[object]',
        'name': 'str',
        'type': 'DSWorkflowStepTypesLoop'
    }

    attribute_map = {
        'expression': 'expression',
        'id': 'id',
        'loop_steps': 'loopSteps',
        'name': 'name',
        'type': 'type'
    }

    def __init__(self, _configuration=None, **kwargs):  # noqa: E501
        """DSLoopStep - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._expression = None
        self._id = None
        self._loop_steps = None
        self._name = None
        self._type = None
        self.discriminator = None

        setattr(self, "_{}".format('expression'), kwargs.get('expression', None))
        setattr(self, "_{}".format('id'), kwargs.get('id', None))
        setattr(self, "_{}".format('loop_steps'), kwargs.get('loop_steps', None))
        setattr(self, "_{}".format('name'), kwargs.get('name', None))
        setattr(self, "_{}".format('type'), kwargs.get('type', None))

    @property
    def expression(self):
        """Gets the expression of this DSLoopStep.  # noqa: E501


        :return: The expression of this DSLoopStep.  # noqa: E501
        :rtype: DSWorkflowComparisonExpression
        """
        return self._expression

    @expression.setter
    def expression(self, expression):
        """Sets the expression of this DSLoopStep.


        :param expression: The expression of this DSLoopStep.  # noqa: E501
        :type: DSWorkflowComparisonExpression
        """
        if self._configuration.client_side_validation and expression is None:
            raise ValueError("Invalid value for `expression`, must not be `None`")  # noqa: E501

        self._expression = expression

    @property
    def id(self):
        """Gets the id of this DSLoopStep.  # noqa: E501


        :return: The id of this DSLoopStep.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this DSLoopStep.


        :param id: The id of this DSLoopStep.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def loop_steps(self):
        """Gets the loop_steps of this DSLoopStep.  # noqa: E501

        A list of #/definitions/DSWorkflowStep. Each element is: A DS Workflow Step. This object should be any of the following object models: [#/definitions/DSServiceStep, #/definitions/DSTransformationStep, #/definitions/DSDocGenStep, #/definitions/DSSignStep]  # noqa: E501

        :return: The loop_steps of this DSLoopStep.  # noqa: E501
        :rtype: list[object]
        """
        return self._loop_steps

    @loop_steps.setter
    def loop_steps(self, loop_steps):
        """Sets the loop_steps of this DSLoopStep.

        A list of #/definitions/DSWorkflowStep. Each element is: A DS Workflow Step. This object should be any of the following object models: [#/definitions/DSServiceStep, #/definitions/DSTransformationStep, #/definitions/DSDocGenStep, #/definitions/DSSignStep]  # noqa: E501

        :param loop_steps: The loop_steps of this DSLoopStep.  # noqa: E501
        :type: list[object]
        """
        if self._configuration.client_side_validation and loop_steps is None:
            raise ValueError("Invalid value for `loop_steps`, must not be `None`")  # noqa: E501

        self._loop_steps = loop_steps

    @property
    def name(self):
        """Gets the name of this DSLoopStep.  # noqa: E501


        :return: The name of this DSLoopStep.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this DSLoopStep.


        :param name: The name of this DSLoopStep.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def type(self):
        """Gets the type of this DSLoopStep.  # noqa: E501


        :return: The type of this DSLoopStep.  # noqa: E501
        :rtype: DSWorkflowStepTypesLoop
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this DSLoopStep.


        :param type: The type of this DSLoopStep.  # noqa: E501
        :type: DSWorkflowStepTypesLoop
        """
        if self._configuration.client_side_validation and type is None:
            raise ValueError("Invalid value for `type`, must not be `None`")  # noqa: E501

        self._type = type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DSLoopStep, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DSLoopStep):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, DSLoopStep):
            return True

        return self.to_dict() != other.to_dict()
